#debuginfo not supported with Go
%global debug_package %{nil}

%global package_name kubevirt
%global kubevirt_commit fefcc7410e62cd1e66e321f0ad6e7372d74f2ca4
%global build_hash %(c=%{kubevirt_commit}; echo ${c:0:7})
%global kubevirt_version 0.49.0-106-gfefcc7410
%global spec_version 0.49.0-106-gfefcc7410
%global spec_release 472
%global pkg_namespace kubevirt

Name:           %{package_name}
Version:        4.10.0
Release:        %{spec_release}%{?dist}
Summary:        %{package_name} - Container native virtualization

License:        ASL 2.0
URL:            https://github.com/kubevirt/kubevirt
Source0:        %{package_name}-%{kubevirt_commit}.tar.gz
# Patch0:         downstream-build-flags.patch

BuildRequires:  libvirt-devel >= 3.9.0
BuildRequires:  rsync >=  3.0
BuildRequires:  sed >=  4.2
BuildRequires:  glibc-static

%if 0%{?rhel} == 8
BuildRequires:  go-compilers-golang-compiler
BuildRequires:  perl >= 5.26
%else
BuildRequires:  go-toolset-1.16-golang-bin >= 1.16
BuildRequires:  go-toolset-1.16 >= 1.16
%endif

%description
CNV distribution based of kubevirt https://github.com/kubevirt/kubevirt/commit/%{kubevirt_commit}

%package        virtctl
Summary:        %{package_name} - virtctl
%description virtctl
CNV kubevirt virtctl

%package        virtctl-redistributable
Summary:        %{package_name} - virtctl-redistributable
%description virtctl-redistributable
CNV kubevirt virtctl executables for linux, MACos, Windows

%enable_gotoolset115
%prep
%setup -q -n %{name}-%{kubevirt_commit}
# %patch0 -p1

%build

mkdir -p go/src/kubevirt.io go/pkg
ln -s ../../../ go/src/kubevirt.io/kubevirt
export GOPATH=$(pwd)/go
cd ${GOPATH}/src/kubevirt.io/kubevirt
KUBEVIRT_GO_BASE_PKGDIR="${GOPATH}/pkg" KUBEVIRT_VERSION=%{kubevirt_version} KUBEVIRT_SOURCE_DATE_EPOCH="$(date +%s)" KUBEVIRT_GIT_COMMIT=%{kubevirt_commit} KUBEVIRT_GIT_VERSION=v%{kubevirt_version} KUBEVIRT_GIT_TREE_STATE="clean" ./hack/build-go.sh install cmd/virtctl
./hack/build-copy-artifacts.sh

%install
mkdir -p %{buildroot}%{_bindir}

chmod 0755 _out/cmd/virtctl/virtctl
install -p -m 0755 _out/cmd/virtctl/virtctl %{buildroot}%{_bindir}/
install -d -m 0755 %{buildroot}%{_datadir}/%{name}/linux
chmod 0755 _out/cmd/virtctl/virtctl-%{kubevirt_version}-linux-amd64
install -p -m 0755 _out/cmd/virtctl/virtctl-%{kubevirt_version}-linux-amd64 %{buildroot}%{_datadir}/%{name}/linux/virtctl
install -d -m 0755 %{buildroot}%{_datadir}/%{name}/macosx
install -p -m 0755 _out/cmd/virtctl/virtctl-%{kubevirt_version}-darwin-amd64 %{buildroot}%{_datadir}/%{name}/macosx/virtctl
install -d -m 0755 %{buildroot}%{_datadir}/%{name}/windows
install -p -m 0755 _out/cmd/virtctl/virtctl-%{kubevirt_version}-windows-amd64.exe %{buildroot}%{_datadir}/%{name}/windows/virtctl.exe


# %files
# %doc

%files virtctl
%{_bindir}/virtctl

%files virtctl-redistributable
%{_datadir}/%{name}/linux/
%{_datadir}/%{name}/macosx/
%{_datadir}/%{name}/windows/

%changelog
* Thu Jul 08 2021 - Antonio Cardace <acardace@redhat.com>
- Use upstream main branch

* Tue Mar 16 2021 - Igor Bezukh <ibezukh@redhat.com>
- Reverting the explicit disable of GO modules for virtctl

* Mon Dec 14 2020 - Igor Bezukh <ibezukh@redhat.com>
- Use upstream release-0.36 branch

* Thu Jul 30 2020 - Stu Gott <sgott@redhat.com>
- Consume releases from master branch until feature freeze

* Thu May 21 2020 - Daniel Belenky <dbelenky@redhat.com>
- Explicitly turn off GO111MODULE

* Fri May 08 2020 - Stu Gott <sgott@redhat.com>
- Use upstream release-0.29 branch

* Thu May 07 2020 - Stu Gott <sgott@redhat.com>
- Add libvirt-daemon-driver-storage-core to virt-launcher

* Fri May 01 2020 - Stu Gott <sgott@redhat.com>
- Consume upstream tags from v0.27.*

* Tue Feb 18 2020 - Stu Gott <sgott@redhat.com>
- Consume releases from master branch until feature freeze

* Wed Feb 12 2020 - Petr Kotas <pkotas@redhat.com>
- Update virt-launcher to use minimal libvirt

* Fri Nov 6 2019 - Petr Kotas <pkotas@redhat.com>
- Align with upstream release v0.23.0

* Fri Oct 11 2019 - Petr Kotas <pkotas@redhat.com>
- Upstream version v0.22.0

* Wed Oct 09 2019 - Petr Kotas <pkotas@redhat.com>
- Prepare for the cnv 2.2

* Thu Oct 03 2019 - Marc Sluiter <msluiter@redhat.com>
- Upstream release: v0.20.8

* Fri Sep 27 2019 - Marc Sluiter <msluiter@redhat.com>
- Upstream release: v0.20.7

* Tue Sep 24 2019 - Marc Sluiter <msluiter@redhat.com>
- Fixed upstream version number

* Tue Sep 17 2019 - Stu Gott <sgott@redhat.com>
- Upstream release: v0.20.6

* Thu Sep 05 2019 - Marc Sluiter <msluiter@redhat.com>
- Upstream release: v0.20.5
- Fixed block datavolumes

* Tue Sep 02 2019 - Marc Sluiter <msluiter@redhat.com>
- Upstream release: v0.20.4
- Fixed virt-launcher memory limit for OKD 4

* Tue Aug 27 2019 - Marc Sluiter <msluiter@redhat.com>
- Upstream release: v0.20.3
- Fixed virtctl console / vnc connection
- Fixed virt-operator replicas for CSV generator

* Tue Aug 20 2019 - Marc Sluiter <msluiter@redhat.com>
- Upstream release: v0.20.2
- Fixed build of containerdisk binary

* Mon Aug 19 2019 - Marc Sluiter <msluiter@redhat.com>
- Added csv-generator to operator image

* Fri Aug 16 2019 - Marc Sluiter <msluiter@redhat.com>
- fixed virt-handler image

* Mon Aug 12 2019 - Marc Sluiter <msluiter@redhat.com>
- Upstream release: v0.20.1

* Wed Jul 31 2019 - Marc Sluiter <msluiter@redhat.com>
- Upstream release: v0.19.0-191-g7674623db
- Removed manifests package

* Tue Jun 18 2019 - Stu Gott <sgott@redhat.com>
- Update to RHEL AV 8.0.1

* Tue Jun 18 2019 - Stu Gott <sgott@redhat.com>
- Upstream release: v0.18.0-79-gda110e831

* Mon Jun 17 2019 - Stu Gott <sgott@redhat.com>
- Upstream release: v0.17.2-7-g0efb20e6d

* Fri Jun 07 2019 - Stu Gott <sgott@redhat.com>
- Upstream release: v0.17.2-4-g8758f33d2

* Thu Jun 06 2019 - Stu Gott <sgott@redhat.com>
- Upstream release: v0.17.2

* Tue Jun 04 2019 - Stu Gott <sgott@redhat.com>
- Upstream release: v0.17.1

* Thu May 16 2019 - Stu Gott <sgott@redhat.com>
- Upstream release: v0.17.0-3-g690215d4f

* Thu May 09 2019 - Stu Gott <sgott@redhat.com>
- Rebuild using RHEL 8 release

* Mon May 06 2019 - Stu Gott <sgott@redhat.com>
- Upstream release: v0.17.0

* Thu May 02 2019 - Stu Gott <sgott@redhat.com>
- Upstream release: v0.17.0-alpha.0-29-ga33118fac
- Remove explicit strip for virtctl binaries

* Thu Apr 25 2019 - Stu Gott <sgott@redhat.com>
- Upstream release: v0.16.0-91-g7ef69d5da

* Thu Apr 18 2019 - Stu Gott <sgott@redhat.com>
- Upstream release: v0.16.0-48-gb37c22bbf

* Thu Apr 11 2019 - Stu Gott <sgott@redhat.com>
- Upstream release: v0.16.0-20-g2427364a5

* Mon Apr 08 2019 - Stu Gott <sgott@redhat.com>
- Upstream release: v0.16.0-9-g8f9e35f38

* Fri Mar 29 2019 - Stu Gott <sgott@redhat.com>
- Remove example templates from KubeVirt RPM
- Explicitly strip virtctl binaries (corrected)

* Thu Mar 28 2019 - Stu Gott <sgott@redhat.com>
- Upstream release: v0.15.0-148-g6c62ce479
- Explicitly strip virtctl binaries

* Thu Mar 21 2019 - Stu Gott <sgott@redhat.com>
- Upstream release: v0.15.0-80-gffac109ec
- updated repository name (cnv-tech-preview -> container-native-virtualization)

* Thu Mar 7 2019 - Stu Gott <sgott@redhat.com>
- Upstream release: v0.15.0

* Thu Feb 28 2019 - Stu Gott <sgott@redhat.com>
- Upstream release: v0.15.0-alpha.0
- Update cnv-libvirt version

* Mon Feb 18 2019 - Marcin Franczyk <mfranczy@redhat.com>
- Upstream release: v0.14.0

* Thu Jan 24 2019 - Marcin Franczyk <mfranczy@redhat.com>
- Upstream release: v0.13.2
- Upstream release: v0.13.1

* Tue Jan 15 2019 - Marcin Franczyk <mfranczy@redhat.com>
- Upstream release: v0.13.0

* Mon Jan 14 2019 - Marcin Franczyk <mfranczy@redhat.com>
- Upstream release: v0.12.0

* Wed Jan  9 2019 - Marcin Franczyk <mfranczy@redhat.com>
- Upstream release: v0.12.0-alpha.3

* Wed Dec 19 2018 - Artyom Lukianov <alukiano@redhat.com>
- Upstream release: v0.12.0-alpha.2

* Thu Dec 13 2018 - Artyom Lukianov <alukiano@redhat.com>
- Upstream release: v0.12.0-alpha.0

* Mon Dec 6 2018 - Artyom Lukianov <alukiano@redhat.com>
- Upstream release: v0.11.0

* Mon Nov 26 2018 - Marcin Franczyk <mfranczy@redhat.com>
- Upstream release: v0.10.0

* Thu Nov 22 2018 - Marcin Franczyk <mfranczy@redhat.com>
- Upstream release: v0.9.6

* Wed Nov  7 2018 - Marc Sluiter <msluiter@redhat.com>
- Upstream release: v0.9.5
- Added v1.3 tag for images

* Wed Nov  7 2018 - Marc Sluiter <msluiter@redhat.com>
- Upstream release: v0.9.4

* Mon Nov  5 2018 - Marc Sluiter <msluiter@redhat.com>
- updated spec release version

* Mon Nov  5 2018 - Marc Sluiter <msluiter@redhat.com>
- updated repository name (cnv13-tech-preview -> cnv-tech-preview)
- removed registry.redhat.com repository prefix in manifest
- updated virt-launcher to use latest cnv-libvirt base image

* Tue Oct 22 2018 - Marc Sluiter <msluiter@redhat.com>
- Upstream release: v0.9.3

* Tue Oct 12 2018 - Marc Sluiter <msluiter@redhat.com>
- Upstream release: v0.9.1
- Changed versioning to vX.Y.Z-S
- Increased SPEC_RELEASE to 2 (tag v1.3.0-1 was used already)
- Applied latest changes from 1.2 branch:
- Remove virt-launcher, virt-controller, virt-api, virt-handler components, they are delivered as containers
- Fixed macosx virtctl name typo
- Fix unsigned jar issue

* Tue Oct 10 2018 - Marc Sluiter <msluiter@redhat.com>
- Upstream release: v0.9.1
- Update to cnv 1.3 and kubevirt 0.9.1

* Wed Sep 12 2018 - Daniel Belenky <dbelenky@redhat.com>
- Upstream release: v0.8.0
- Update upstream sources to new 0.8.0 release

* Sun Aug 26 2018 - alivigni <alivigni@redhat.com>
- Upstream release: v0.6.4
- Add new upstream sources for kubevirt-0.6.4-1.2649da0
- Increase spec_release # to 1 and build_hash to 2649da0

* Thu Aug 23 2018 - alivigni <alivigni@redhat.com>
- Upstream release: v0.6.4-cnv-1.1-2
- Add new upstream sources for kubevirt-0.6.4-1.92ee578
- Increase spec_release # to 1 and build_hash to 92ee578

* Thu Aug 23 2018 - alivigni <alivigni@redhat.com>
- Upstream release: v0.6.4-cnv-1.1-2
- Add new upstream sources for kubevirt-0.6.4-1.92ee578
- Increase spec_release # to 1 and build_hash to 92ee578

* Tue Aug 21 2018 - alivigni <alivigni@redhat.com>
- Upstream release: v0.6.4-cnv-1.1
- Add new upstream sources for kubevirt-0.6.4-1.02315df
- Increase spec_release # to 1 and build_hash to 02315df

* Mon Jul 30 2018 - alivigni <alivigni@redhat.com>
- Upstream release: v0.6.3
- Add new upstream sources for kubevirt-0.6.3-1.9d48bd1
- Increase spec_release # to 1 and build_hash to 9d48bd1

* Wed Jul 18 2018 - rhallise <rhallise@redhat.com>
- Upstream release: v0.6.2
- Increase spec_release # to 4 and build_hash to 467db5c
- Add vm templates to manifest sub rpm

* Tue Jul 17 2018 - <rhallise@redhat.com>
- Include j2 templates in manifests sub rpm

* Fri Jul  6 2018 -  <@redhat.com>
- Upstream release: v0.6.2
- Add new upstream sources for kubevirt-0.6.2-1.467db5c
- Increase spec_release # to 1 and build_hash to 467db5c
- Added j2 function to replace j2 command required by build

* Thu Jul 05 2018 - joherr - kubevirt-0.6.2-0.-----
- removed patch to manifests for binary locations as this should be fixed upstream in release 0.6.2
- removed patch for QEMU process detection (BZ 1596317) as this should be fixed upstream in release 0.6.2
- set build_hash to ----- in comments to prepare for automation of build
- reset spec_release to 0 since version change to stable build 0.6.2 from 0.7.0

* Mon Jul 02 2018 - sreichar - kubevirt-0.7.0-22.a6de7bc
- builds for CNV1.1 will come from release-0.6 branch
- back out KUBEVIRT_GO_BASE_PKGDIR
- put back downstream-build-flags.patch
- bump spec release to 25

* Fri Jun 29 2018 - sreichar
- Define KUBEVIRT_GO_BASE_PKGDIR
- Apply BZ1596317.patch
- bumped spec_release to 24

* Thu Jun 28 2018 - sreichar
- Remove build patch since change merged upstream
- bumped spec_release to 23

* Thu Jun 28 2018 - alivigni <alivigni@redhat.com>
- Upstream release: v0.7.0-alpha.2
- Increase spec_release # to 22 and build_hash to a6de7bc
- Add new upstream sources for kubevirt-0.7.0-22.a6de7bc

* Tue Jun 26 2018 - alivigni <alivigni@redhat.com>
- Upstream release: v0.7.0-alpha.4
- Add new upstream sources for kubevirt-0.7.0-20.6e81caf
- Increase spec_release # to 20 and build_hash to 6e81caf

* Mon Jun 25 2018 - alivigni <alivigni@redhat.com>
- Add new upstream sources for kubevirt-0.7.0-19.a6de7bc
- Increase spec_release # to 19 and build_hash to a6de7bc

* Mon Jun 25 2018 - alivigni <alivigni@redhat.com>
- Fixed wrong date in spec file from sreichar

* Mon Jun 25 2018 - alivigni <alivigni@redhat.com>
- Add new upstream sources for kubevirt-0.7.0-17.a6de7bc
- Increase spec_release # to 17 and build_hash to a6de7bc

* Mon Jun 25 2018 - rhallisey <rhallisey@redhat.com>
- Upstream release: v0.7.0-alpha.2
- Add new upstream sources for kubevirt-0.7.0-16.a6de7bc
- Increase spec_release # to 16 and build_hash to a6de7bc

* Mon Jun 25 2018 - rhallisey <rhallise@redhat.com> 0.7.0-15
- Revert back to old sources
- Update Makefile to pickup changes

* Fri Jun 22 2018 - rhallisey <rhallise@redhat.com> 0.7.0-14
- Move back to v0.7.0-alpha.2

* Fri Jun 22 2018 - joherr <joherr@redhat.com> 0.7.0-13
- Added patch to manifests file

* Thu Jun 21 2018 - sreichar 0.7.0-12
- change prefix from openshift3 to cnv11-tech-preview

* Wed Jun 20 2018 - rhallisey 0.7.0-11
- Add a Makefile to the dist-git

* Wed Jun 20 2018 - rhallisey 0.7.0-10
- Simplify spec file.  Patch from Roman Mohn <rmohr@redhat.com>

* Tue Jun 19 2018 - rhallisey 0.7.0-9
- Set container tags to 1.1

* Tue Jun 19 2018 - alivigni 0.7.0-8
- Upstream release v0.7.0-alpha.3
- Update this file and add upstream sources for v0.7.0-alpha.3
- Increase spec_release to 8 and build_hash d265c3c

* Tue Jun 19 2018 - alivigni 0.7.0-7
- Upstream release v0.7.0-alpha.2
- Update this file and add upstream sources for v0.7.0-alpha.2

* Mon Jun 18 2018 - sreichar
- Add virtctl redistributable back
- Spec_release bumped to 6

* Mon Jun 18 2018 - alivigni
- Added build_hash and spec_release vars to spec file for consistency
- Spec_release bumped to 5

* Mon Jun 18 2018 - rhallisey
- Configure the downstream image tag and prefix in the manifests

* Fri Jun 15 2018 - rhallisey
- Pull in kubevirt-0.7.0-alpha.1.5167d4d

* Thu Jun 14 2018 - rhallisey
- Add build args to hack/build-go.sh

* Thu Jun 14 2018 - alivigni
- kubevirt update to CNV NVR kubevirt-0.7.0-1.d07a440

* Mon Jun 11 2018 - sreichar
- install binaries to %{_bindir}
- install manifest to %{_datadir}/%{name}/manifest
- install virt-launcher artifacts to %{_datadir}/%{name}/
- remove sh.sh hack - move to container dist-git
- add depencency for sudo
- create kubevurt-virtctl-redistributable package

* Mon Jun 11 2018 - alivigni
- kubevirt update to CNV NVR kubevirt-0.6.0-1.git.0.cf13e2b

* Wed Jun  6 2018 - alivigni
- kubevirt update to CNV NVR kubevirt-0.5.1-1.git.0.7315047

* Wed May 16 2018 Steve Reichard - ver 0.5.1alpha1
- kubevirt new build call requires rsync and sed

* Wed May 16 2018 Steve Reichard - ver 0.5.1alpha1
- kubevirt small changes for artifacts now all being in _out

* Wed May 09 2018 Ari LiVigni - ver 0.5.1alpha1
- kubevirt update to v 0.5.1-alpha-1 - alivigni

* Sat Apr 28 2018 Ari LiVigni - 0.5.0
- kubevirt update to 0.5.0 - alivigni

* Fri Apr 27 2018 Ari LiVigni - 0.5.0alpha.1
- kubevirt update to 0.5.0-alpha.1 - alivigni

* Thu Apr 26 2018 Varun Khanna - 0.4.1
- kubevirt rpm testing - vkhanna
